function get_music_ptr(name) -- arg str, return musPtr
    return ffi.cast("int(*__thiscall)(int, const char*)", 0x4B4E80)(nRes(20), name)
end

function get_music_state(musPtr) -- arg musPtr, return bool
    return ffi.cast("int(*__thiscall)(int)", 0x4B55B0)(musPtr) ~= 0
end

function stop_music(musPtr) -- arg musPtr
    ffi.cast("int(*__thiscall)(int)", ffi.cast("int**", musPtr)[0][8])(musPtr)
end


function main(self)
    
    local Claw = GetClaw()

    if self.State == 0 then
        self.Flags.AlwaysActive, self.DrawFlags.NoDraw = true, true
        self.musicNames = { "CUSTOM", "CUSTOM2", "LEVEL", "POWERUP" }
        self.State = 1

    elseif self.State == 1 and Claw.X > self.XMin and Claw.X < self.XMax and Claw.Y > self.YMin and Claw.Y < self.YMax then
        for i, name in ipairs(self.musicNames) do
            local musPtr = get_music_ptr(name)
            if get_music_state(musPtr) then
                stop_music(musPtr)
            end
        end
        self.State = 2
    
    elseif self.State == 2 and not (Claw.X > self.XMin and Claw.X < self.XMax and Claw.Y > self.YMin and Claw.Y < self.YMax) then
        self.State = 1
    end
end
